/**
 * Created by zenit1 on 22/12/2016.
 */
"use strict";



const async = require('async');
const config        = require('./config');

const logger        = new config.Logger("TestCredential");

const zeroLevelFqdn = 'qvk0jxg6xawnyyst.npc9ijjniqcp7ln7.v1.d.beameio.net';

const store = new(require('../../src/services/BeameStoreV2'))();
const CommonUtils = config.CommonUtils;

let devCreds = store.getCredential(zeroLevelFqdn);


function _getRandomRegistrationData(prefix) {
	let rnd = config.beameUtils.randomString(8);
	return {
		name:  prefix + rnd,
		email: rnd + '@example.com'
	};
}

let successCounter = 0;


function createCreds() {

	function createWithLocal(cb, ind) {

		console.log(`local call ${ind} received`);

		let data = _getRandomRegistrationData(`${ind}-${zeroLevelFqdn}-child-1-`);
		logger.info(`Creating entity ${data.name} under ${zeroLevelFqdn}`);

		devCreds.createEntityWithLocalCreds(zeroLevelFqdn, data.name, data.email).then(metadata => {

			logger.info(`metadata received for ${data.name}`, metadata);
			successCounter++;
			cb(null, metadata);

		}).catch(error=> {
			let msg = config.Logger.formatError(error);

			logger.error(msg, error);
			cb(error, null);
		});
	}

	function createWithToken(cb, ind) {
		console.log(`token call ${ind} received`);

		let newData2 = _getRandomRegistrationData(`${ind}-${zeroLevelFqdn}-child-1-`);
		logger.info(`Creating entity ${newData2.name} under ${zeroLevelFqdn}`);

		devCreds.signWithFqdn(zeroLevelFqdn, CommonUtils.generateDigest(newData2)).then(authToken=> {
			devCreds.createEntityWithAuthToken(authToken, newData2.name, newData2.email).then(metadata => {

				logger.info(`metadata received for ${newData2.name}`, metadata);
				successCounter++;
				cb(null, metadata);

			});
		}).catch(error=> {
			let msg = config.Logger.formatError(error);

			logger.error(msg, error);
			cb(error, null);
		});
	}

	async.parallel(
		[

			cb=>{createWithLocal(cb,1)},
			cb=>{createWithLocal(cb,2)},
			// cb=>{createWithLocal(cb,3)},
			// cb=>{createWithLocal(cb,4)},
			// cb=>{createWithLocal(cb,5)},
			// cb=>{createWithLocal(cb,6)},
			// cb=>{createWithLocal(cb,7)},
			// cb=>{createWithLocal(cb,8)},
			// cb=>{createWithLocal(cb,9)},
			// cb=>{createWithLocal(cb,10)},
			// cb=>{createWithLocal(cb,11)},
			// cb=>{createWithLocal(cb,12)},
			// cb=>{createWithLocal(cb,13)},
			// cb=>{createWithLocal(cb,14)},
			// cb=>{createWithLocal(cb,15)},
			// cb=>{createWithLocal(cb,16)},
			// cb=>{createWithLocal(cb,17)},
			// cb=>{createWithLocal(cb,18)},
			// cb=>{createWithLocal(cb,19)},
			// cb=>{createWithLocal(cb,20)},
			// cb=>{createWithLocal(cb,21)},
			// cb=>{createWithLocal(cb,22)},
			// cb=>{createWithLocal(cb,23)},
			// cb=>{createWithLocal(cb,24)},
			// cb=>{createWithLocal(cb,25)},
			// cb=>{createWithLocal(cb,26)},
			// cb=>{createWithLocal(cb,27)},
			// cb=>{createWithLocal(cb,28)},
			// cb=>{createWithLocal(cb,29)},
			// cb=>{createWithLocal(cb,30)},
			// cb=>{createWithLocal(cb,31)},
			// cb=>{createWithLocal(cb,32)},
			// cb=>{createWithLocal(cb,33)},
			// cb=>{createWithLocal(cb,34)},
			// cb=>{createWithLocal(cb,35)},
			// cb=>{createWithLocal(cb,36)},
			// cb=>{createWithLocal(cb,37)},
			// cb=>{createWithLocal(cb,38)},
			// cb=>{createWithLocal(cb,39)},
			// cb=>{createWithLocal(cb,40)},
			// cb=>{createWithLocal(cb,41)},
			// cb=>{createWithLocal(cb,42)},
			// cb=>{createWithLocal(cb,43)},
			// cb=>{createWithLocal(cb,44)},
			// cb=>{createWithLocal(cb,45)},
			// cb=>{createWithLocal(cb,46)},
			// cb=>{createWithLocal(cb,47)},
			// cb=>{createWithLocal(cb,48)},
			// cb=>{createWithLocal(cb,49)},
			// cb=>{createWithLocal(cb,50)},
			// cb=>{createWithLocal(cb,51)},
			// cb=>{createWithLocal(cb,52)},
			// cb=>{createWithLocal(cb,53)},
			// cb=>{createWithLocal(cb,54)},
			// cb=>{createWithLocal(cb,55)},
			// cb=>{createWithLocal(cb,56)},
			// cb=>{createWithLocal(cb,57)},
			// cb=>{createWithLocal(cb,58)},
			// cb=>{createWithLocal(cb,59)},
			// cb=>{createWithLocal(cb,60)},
			// cb=>{createWithLocal(cb,1)},
			// cb=>{createWithLocal(cb,2)},
			// cb=>{createWithLocal(cb,3)},
			// cb=>{createWithLocal(cb,4)},
			// cb=>{createWithLocal(cb,5)},
			// cb=>{createWithLocal(cb,6)},
			// cb=>{createWithLocal(cb,7)},
			// cb=>{createWithLocal(cb,8)},
			// cb=>{createWithLocal(cb,9)},
			// cb=>{createWithLocal(cb,10)},
			// cb=>{createWithLocal(cb,11)},
			// cb=>{createWithLocal(cb,12)},
			// cb=>{createWithLocal(cb,13)},
			// cb=>{createWithLocal(cb,14)},
			// cb=>{createWithLocal(cb,15)},
			// cb=>{createWithLocal(cb,16)},
			// cb=>{createWithLocal(cb,17)},
			// cb=>{createWithLocal(cb,18)},
			// cb=>{createWithLocal(cb,19)},
			// cb=>{createWithLocal(cb,20)},
			// cb=>{createWithLocal(cb,21)},
			// cb=>{createWithLocal(cb,22)},
			// cb=>{createWithLocal(cb,23)},
			// cb=>{createWithLocal(cb,24)},
			// cb=>{createWithLocal(cb,25)},
			// cb=>{createWithLocal(cb,26)},
			// cb=>{createWithLocal(cb,27)},
			// cb=>{createWithLocal(cb,28)},
			// cb=>{createWithLocal(cb,29)},
			// cb=>{createWithLocal(cb,30)},
			// cb=>{createWithLocal(cb,31)},
			// cb=>{createWithLocal(cb,32)},
			// cb=>{createWithLocal(cb,33)},
			// cb=>{createWithLocal(cb,34)},
			// cb=>{createWithLocal(cb,35)},
			// cb=>{createWithLocal(cb,36)},
			// cb=>{createWithLocal(cb,37)},
			// cb=>{createWithLocal(cb,38)},
			// cb=>{createWithLocal(cb,39)},
			// cb=>{createWithLocal(cb,40)},
			// cb=>{createWithLocal(cb,41)},
			// cb=>{createWithLocal(cb,42)},
			// cb=>{createWithLocal(cb,43)},
			// cb=>{createWithLocal(cb,44)},
			// cb=>{createWithLocal(cb,45)},
			// cb=>{createWithLocal(cb,46)},
			// cb=>{createWithLocal(cb,47)},
			// cb=>{createWithLocal(cb,48)},
			// cb=>{createWithLocal(cb,49)},
			// cb=>{createWithLocal(cb,50)},
			// cb=>{createWithLocal(cb,51)},
			// cb=>{createWithLocal(cb,52)},
			// cb=>{createWithLocal(cb,53)},
			// cb=>{createWithLocal(cb,54)},
			// cb=>{createWithLocal(cb,55)},
			// cb=>{createWithLocal(cb,56)},
			// cb=>{createWithLocal(cb,57)},
			// cb=>{createWithLocal(cb,58)},
			// cb=>{createWithLocal(cb,59)},
			// cb=>{createWithLocal(cb,60)}


		],
		error=> {
			if (error) {
				console.error(`create children`, error);
			}

			console.log(`***************************************** ${successCounter} creds created**************************************`);

			process.exit(0);
		}
	);
}

createCreds();