/**
 * Created by zenit1 on 13/03/2017.
 */
"use strict";

const express      = require('express');
const router       = express.Router();

const beameSDK          = new require('../../index.js');

function setExpressApp(router) {
	let app    = express();

	app.use('/', router);
	return app;
}

function assertValidCertMiddleware(req, res, next) {
	const https       = require("https");
	//noinspection JSUnresolvedVariable
	if (req.client.authorized) {

		try {
			//noinspection JSUnresolvedFunction,JSUnresolvedVariable
			let cert           = req.connection.getPeerCertificate(),
			    subject        = cert ? cert.subject : null,
			    segments       = subject ? subject.CN.split('.') : [],
			    parent_segment = segments && segments.length >= 2 ? segments[1] : null;

			if (parent_segment === config.BeameInternalAppFqdnSegment) {
				next();
			}
			else {
				res.status(403).end('403');
			}
		}
		catch (e) {
			logger.error(e);
			res.status(400).end('400');
		}

	}
	else {
		res.status(403).end('403');
	}
}

router.use(assertValidCertMiddleware);

const appAdmin     = setExpressApp(router, true, 'admin');

beameSDK.BaseHttpsServer('uss3unm9zivxx11a.gjjpak0yxk8jhlxv.v1.p.beameio.net', {
	requestCert:        true,
	rejectUnauthorized: false
}, appAdmin, () => {
	console.log(`Admin server started on `);
});